.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include reg.inc
.data
MsgText         db "Custom Window Shapes Example",0ah
                db "Actually coded by ramguru",0ah
                db "Edited by Falcon to show how ",0ah
                db "to make custom window shapes on",0ah
                db "Child Windows",0
MsgCap          db "About",0
RsrcName        db "RANGE",0
RsrcType        db "RGN",0
RsrcHand        dd ?
RsrcSize        dd ?
RsrcPoint       dd ?
brush           dd ?
.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax

    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

;########################################################################

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	.if uMsg==WM_INITDIALOG
; -->   LOAD BITMAP FROM EXECUTABLE (RESOURCE)
        invoke  LoadBitmap,hInstance,20000                   
        
; -->   USE THAT BITMAP AS WINDOW BACKGROUND            
        invoke  CreatePatternBrush,eax
        mov     brush, eax
; -->   LOAD REGION_DATA (SEE API REF FOR QUESTIONS)
        invoke  FindResource,hInstance,addr RsrcName,addr RsrcType
        mov     RsrcHand, eax

        invoke  LoadResource,hInstance,eax
        mov     RsrcPoint, eax

        invoke  SizeofResource,hInstance,RsrcHand
        mov     RsrcSize, eax

        invoke  LockResource,RsrcPoint
        mov     RsrcPoint, eax          

; -->   CREATE REGION AND PASS IT TO OUR WINDOW 
        invoke  ExtCreateRegion,NULL,RsrcSize,eax
        invoke  SetWindowRgn,hWin,eax,TRUE

	.elseif uMsg==WM_CTLCOLORDLG
		mov eax, brush
		ret
		
	.elseif uMsg == WM_COMMAND
		.if wParam == 1001
		Invoke DialogBoxParam,hInstance, IDD_DIALOG2, hWin, addr ChldDlg, NULL
		.elseif wParam == 1002
            Invoke MessageBox, hWin, addr MsgText, addr MsgCap, MB_OK+MB_ICONINFORMATION
            .elseif wParam == 1003
		Invoke PostQuitMessage,NULL
		.endif
	
      .elseif uMsg==WM_LBUTTONDOWN
		invoke SendMessage,hWin,WM_NCLBUTTONDOWN,HTCAPTION,lParam	
	
      .elseif uMsg == WM_DESTROY
            Invoke DeleteObject, brush
      .elseif uMsg==WM_CLOSE
		invoke PostQuitMessage, 0
	.else
		mov	eax,FALSE
		ret
	.endif
	mov	eax,TRUE
	ret

DlgProc endp

ChldDlg PROC hDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    .if uMsg==WM_INITDIALOG
	mov  eax,TRUE
    
    ; --> Here we don't need to load the bitmap and find RGN again
    ; --> Since it's already been done. We just need to create the Region
    ; --> and Set it
    
        invoke  ExtCreateRegion,NULL,RsrcSize,RsrcPoint
        invoke  SetWindowRgn,hDlg,eax,TRUE

	.elseif uMsg==WM_CTLCOLORDLG
		mov eax, brush
		ret
     .elseif  uMsg == WM_COMMAND
      .if wParam == 1003
       Invoke EndDialog, hDlg, NULL
       .endif
     .elseif uMsg==WM_LBUTTONDOWN
		invoke SendMessage,hDlg,WM_NCLBUTTONDOWN,HTCAPTION,lParam
	 .elseif uMsg == WM_CLOSE
	 	Invoke EndDialog, hDlg, NULL
	.else
	mov eax, FALSE
	.endif
	ret
ChldDlg	endp
end start
